<%@ page import="java.sql.*" %>
<%@ page import="java.io.*, java.net.*, java.util.*" %>
<%@ page import="org.w3c.dom.*, javax.xml.parsers.*" %>
<%@ page import="org.json.JSONObject" %>
<%@ page import="org.json.JSONArray" %>
<%@ page import="org.json.JSONException" %>
<%@ page import="sun.misc.BASE64Decoder" %>
<%@ page import="sun.misc.BASE64Encoder" %>
<%@ page import="javax.crypto.spec.SecretKeySpec" %>
<%@ page import="javax.crypto.Mac" %>
<%@ page import="java.io.UnsupportedEncodingException" %>
<%@ page import="java.security.InvalidKeyException" %>
<%@ page import="java.security.NoSuchAlgorithmException" %>

<%
            //System.out.println("init");
            initialize();
            //System.out.println("request");
            printRequestParams(request, logger);
            //System.out.println("signed_request");
            String sigreq = request.getParameter("signed_request");
            if (sigreq == null) {
                out.write(errMessage);
                return;
            }
            //System.out.println("parsing");
            JSONObject data = parseSignedRequest(sigreq, appSecret);
            if (data != null) {
                logger.println("data: " + data.toString());
                logger.flush();
                if (data.has("oauth_token") && data.has("user_id")) {
                    String fb_id = data.getString("user_id");
                    String oauth_token = data.getString("oauth_token");
                    String ipAddress = request.getRemoteAddr();

                    if (!checkUserPermissions(oauth_token)) {
                        authorize(out);
                        return;
                    }

                    if (!login(oauth_token, fb_id, ipAddress)) {
                        out.write(errMessage);
                        out.write(loginError);
                        return;
                    }
                    logger.println("Login success: " + fb_id);
                    logger.println("Session key: " + sessionKey);
                    logger.flush();
                } else {
                    authorize(out);
                    return;
                }
            } else {
                out.write(errMessage);
                return;
            }

            logger.close();
%>

<%!    public String appId = "148984718491784";
    public String appSecret = "484c30ed7c149711c62fcc7c23a0ec70";
    public String appUrl = "http://apps.facebook.com/testing_tp/";
    public String permissions[] = {"publish_stream", "offline_access", "friends_hometown"};
    public String sessionKey = "";
    public String locale = "";
    public String name = "";
    public String sqlConnectionURL = "";
    public String sqlLogin = "";
    public String sqlPass = "";
    public final String errMessage = "Server error! Sorry.";
    public String loginError = "";
    public PrintWriter logger = null;
    public JSONObject jsonObject = new JSONObject();
    public JSONArray jsonArrayFriends = new JSONArray();
    private static final String ALGORITHM_HMAC_SHA_256 = "HmacSHA256";

    public JSONObject parseSignedRequest(String signedRequest, String secret) {
        String[] list = signedRequest.split("\\.");
        if (list.length >= 2) {
            String encodedSig = list[0];
            String payload = list[1];

            try {
                JSONObject data = new JSONObject(new String(fbDecodeBase64(payload)));
                if (!"HMAC-SHA256".equalsIgnoreCase(data.getString("algorithm"))) {
                    logger.println("Unknown algorithm. Expected HMAC-SHA256, signedRequest={}" + signedRequest);
                    return null;
                }

                if (verifySignedRequest(payload, encodedSig, secret)) {
                    //logger.println("Signed Requet verfied! signedRequest={}" + signedRequest);
                    return data;

                } else {
                    //logger.error("Invalid Signed Requet! signedRequest={}", signedRequest);
                }

            } catch (IOException e) {
                //logger.error("Error Decoding Base64, signedRequest="+signedRequest, e);
            } catch (JSONException e) {
                //logger.error("Invalid Json Data, signedRequest="+signedRequest, e);
            }
        }
        return null;
    }

    public void authorize(JspWriter out) {
        String url = getAuthorizeUrl();
        //System.out.print("<script type='text/javascript'>top.location.href = '" + url + "';</script>");
        //System.out.flush();

        try {
            out.write("<script type='text/javascript'>top.location.href = '" + url + "';</script>");
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public boolean checkUserPermissions(String oauth_token) {
        //use Old REST API to check user permissions
        try {
            String url;
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            for (String str : permissions) {
                url = "https://api.facebook.com/method/users.hasapppermission?api_key=" + appId + "&ext_perm=" + str + "&access_token=" + oauth_token;
                InputStream stream = sendGETStream(url);
                Document doc = db.parse(stream);
                NodeList nlist = doc.getElementsByTagName("users_hasapppermission_response");
                Boolean value = Boolean.parseBoolean(nlist.item(0).getTextContent().equals("0") ? "false" : "true");
                //logger.println("ext_perm = " + str + " - " + value);
                if (!value) {
                    return false;
                }
            }
        } catch (Exception e) {
            logger.println(e.getMessage());
            return false;
        }

        return true;
    }

    public String getAuthorizeUrl() {
        String result = "https://graph.facebook.com/oauth/authorize?client_id=" + appId + "&redirect_uri=" + appUrl;
        if (permissions.length > 0) {
            result = result.concat("&scope=");
        }
        for (String str : permissions) {
            result = result.concat(str + ",");
        }
        return result;
        //return (permissions.length > 0) ? result.substring(0, result.length() - 1) : result;
    }

    public boolean login(String oauth_token, String fb_id, String ipAddress) {

        try {
            System.out.println("try login");
            //jsonObject.put("oauth_token", oauth_token);
            //jsonObject.put("fb_id", fb_id);
            //jsonObject.put("ip", ipAddress);

            //get profile data
            String urlStr = "https://graph.facebook.com/me?access_token=" + oauth_token;
            String response = sendGET(urlStr);
            //logger.println("me? response = " + response);
            //logger.flush();
            if (response != null) {
                JSONObject profile = new JSONObject(response);
                if (profile.has("error")) {
                    loginError = profile.getJSONObject("error").toString();
                    return false;
                }
                //get user's picture
                urlStr = "https://graph.facebook.com/me/picture?access_token=" + oauth_token;
                String pic = getPicture(urlStr);
                profile.put("picture", pic);

                //get user's friends list
                urlStr = "https://graph.facebook.com/me/friends?fields=id,name,birthday,hometown&access_token=" + oauth_token;
                JSONArray friends = new JSONObject(sendGET(urlStr)).getJSONArray("data");
                //decode friend's array and find all hometown's
               /*
                for (int i=0; i<friends.length(); i++){
                JSONObject friend = friends.getJSONObject(i);
                urlStr = "https://graph.facebook.com/"+ friend.getInt("id") +"?access_token=" + oauth_token;
                System.out.println(urlStr);
                JSONObject pr = new JSONObject(sendGET(urlStr)).getJSONObject("data");
                System.out.println(pr.toString());
                friends.getJSONObject(i).put("hometown",pr.getString("hometown"));
                }
                 */
                //profile.put("friends", friends.toString());
                //logger.println("friends = " + friends.toString());
                jsonArrayFriends = friends;

                jsonObject.put("profile", profile);
            } else {
                return false;
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

        return true;
    }

    public InputStream sendGETStream(String urlStr) {
        try {
            URL url = new URL(urlStr);
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.connect();
            InputStream result = urlConnection.getInputStream();
            //urlConnection.disconnect();
            return result;
        } catch (Exception e) {
            logger.println(e.getMessage());
            //e.printStackTrace();
            return null;
        }
    }

    public String sendGET(String urlStr) {
        try {
            InputStream stream = sendGETStream(urlStr);
            return streamToStr(stream);
        } catch (Exception e) {
            logger.println(e.getMessage());
            //e.printStackTrace();
            return null;
        }
    }

    public String getPicture(String urlStr) {
        try {
            URL url = new URL(urlStr);
            HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.connect();
            return urlConnection.getHeaderField("Location");
        } catch (Exception e) {
            logger.println(e.getMessage());
            //e.printStackTrace();
            return null;
        }
    }

    public boolean initialize() {
        try {
            //Class.forName("com.mysql.jdbc.Driver").newInstance();
            logger = new PrintWriter(new FileOutputStream("fb_jsp.log", true));
            //initSqlConnParams();
        } catch (Exception e) {
            logger.println(e.getMessage());
            return false;
        }
        return true;
    }

    public static boolean verifySignedRequest(String payload, String encodedSig, String secret) {
        try {
            byte[] keyBytes = secret.getBytes("UTF-8");

            SecretKeySpec secretKeySpec = new SecretKeySpec(keyBytes, ALGORITHM_HMAC_SHA_256);
            Mac mac = Mac.getInstance(ALGORITHM_HMAC_SHA_256);
            mac.init(secretKeySpec);
            byte[] macBytes = mac.doFinal(payload.getBytes());

            String encodedMacBytes = fbEncodeBase64(macBytes);
            return encodedSig.equals(encodedMacBytes);

        } catch (NoSuchAlgorithmException e) {
            //logger.error("Unable to get HmacsSHA256 instance", e);
        } catch (InvalidKeyException e) {
            //logger.error("Invalid Key for HmacsSHA256", e);
        } catch (UnsupportedEncodingException e) {
            //logger.error("Error Getting Bytes Array, secret="+secret, e);
        }
        return false;
    }

    private static String fbEncodeBase64(byte[] bytes) {
        String encodedMacBytes = new BASE64Encoder().encode(bytes);
        encodedMacBytes = encodedMacBytes.replaceAll("\\+", "-");
        encodedMacBytes = encodedMacBytes.replaceAll("/", "_");
        if (encodedMacBytes.endsWith("=")) {
            encodedMacBytes = encodedMacBytes.substring(0, encodedMacBytes.length() - 1);
        }
        return encodedMacBytes;
    }

    private static byte[] fbDecodeBase64(String encoded) throws IOException {
        String _encoded = encoded.replaceAll("-", "+");
        _encoded = _encoded.replaceAll("_", "/");
        return new BASE64Decoder().decodeBuffer(_encoded);
    }

    public String streamToStr(InputStream in) throws IOException {
        StringBuffer out = new StringBuffer();
        byte[] b = new byte[4096];
        for (int n; (n = in.read(b)) != -1;) {
            out.append(new String(b, 0, n));
        }
        return out.toString();
    }

    public void printRequestParams(HttpServletRequest request, PrintWriter pw) {
        pw.println("+++++++++++++");
        pw.println(request.getRequestURL().toString());

        System.out.println(request.getRequestURL().toString());

        Enumeration paramNames = request.getParameterNames();
        while (paramNames.hasMoreElements()) {
            String paramName = (String) paramNames.nextElement();
            pw.println("paramName - " + paramName);
            String[] paramValues = request.getParameterValues(paramName);
            if (paramValues.length == 1) {
                String paramValue = paramValues[0];
                if (paramValue.length() == 0) {
                    pw.println("No Value");
                } else {
                    pw.println(paramValue);
                }
            } else {
                for (int i = 0; i < paramValues.length; i++) {
                    pw.println(paramValues[i] + ";");
                }
            }
        }
        pw.flush();
    }
%>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
    <head>
        <title>TP</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
        <script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
        <style type="text/css">
            html { height: 100% }
            body { height: 100%; margin: 0px; padding: 0px }
            #map_canvas { height: 100% }
        </style>
        <script type="text/javascript">
            var profile = <%= jsonObject%>;
            var friends = <%= jsonArrayFriends%>;
            var geocoder;
            var map;
            var query = profile['profile']['hometown']['name'];


            function initialize() {
                geocoder = new google.maps.Geocoder();
                var myOptions = {
                    zoom: 8,
                    mapTypeId: google.maps.MapTypeId.ROADMAP
                }
                map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
                codeAddress();
                for (var i=0;i<friends.length; i++){
                    if (friends[i]['hometown'] != undefined)
                        codeFriendAddress(friends[i]['hometown']['name'],friends[i]['name'] );
                }

                displayFriends();
                window.fbAsyncInit = function() {
                    FB.Canvas.setAutoResize();
                }
            }

            //
            function codeFriendAddress(address, name){
                geocoder_fr = new google.maps.Geocoder();
                geocoder_fr.geocode( { 'address': address}, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        //map.setCenter(results[0].geometry.location);
                        var marker = new google.maps.Marker({
                            map: map,
                            title: name + " " + address,
                            position: results[0].geometry.location
                        });
                    } else {
                        //alert("Geocode was not successful for the following reason: " + status);
                    }
                });
            }

            function displayFriends() {
                var list="";
                target = document.getElementById("listeOfFriends");
                for (var i=0;i<friends.length; i++){
                    list += friends[i]['name'] + "<BR/>" ;
                }
                target.innerHTML = list;
            }

            function codeAddress() {
                var address = query;
                geocoder.geocode( { 'address': address}, function(results, status) {
                    if (status == google.maps.GeocoderStatus.OK) {
                        map.setCenter(results[0].geometry.location);
                        var marker = new google.maps.Marker({
                            map: map,
                            position: results[0].geometry.location
                        });
                    } else {
                        alert("Geocode was not successful for the following reason: " + status);
                    }
                });
            }
        </script>
        <script src="http://connect.facebook.net/en_US/all.js"></script>
    </head>
    <body onload="initialize()">
        <div id="fb-root"></div>
        <h1>Liste des amis</h1>
        <div id="listeOfFriends"></div>
        <!--<%= jsonObject%>-->
        <div id="map_canvas" style="width:100%; height:100%"></div>

    </body>
</html>